package lecture;

public class ArrayTest {

	public static int SIZE = 3;

	public static String intArrayToString(int[] a){
		int len = a.length;
		if (len == 0) {
			return "{}";
		} else {
			String s = "";
			for (int i=0; i<a.length-1; i++) {
				s = s + a[i] + ",";
			}
			return "{"+s+a[len-1]+"}";
		}
	}

	public static String intArrayArrayToString(int[][] a){
		int len = a.length;
		if (len == 0) {
			return "{}";
		} else {
			String s = "";
			for (int i=0; i<a.length-1; i++) {
				s = s + "\n " + intArrayToString(a[i]) + ",";
			}
			return "{"+s+"\n "+intArrayToString(a[len-1])+"\n}";
		}
	}

	public static void main(String[] args) {

		int someInteger = 10;
		
		int[] dailyRate = { 4, 1, 5, 6, 9, 7, 3 };
		
		System.out.println("testing printing of dailyRate[2]");
		System.out.println(dailyRate[2]);

		dailyRate[6] = dailyRate[0];
		dailyRate[6]++;

		// TEST 1: printing out array
		System.out.println("TEST 1: printing out array");
		System.out.println(intArrayToString(dailyRate));

        // a couple of 2-D arrays
		
		int[][] x = {{1,2,3},{4,5,6},{7,8,9}};
		int[][] y = {{5,4,3},{6,5,4},{7,6,5}};

		{
			
			int[][] result = {{0,0,0},{0,0,0},{0,0,0}};
			
			int i = 0;
			while (i < SIZE) {
				int j = 0;
				while (j < SIZE) {
					int k = 0;
					while (k < SIZE) {
						result[i][j] = result[i][j] 
						                         + x[i][k] * y[k][j];
						k = k + 1;
					}
					j = j + 1;
				}
				i = i + 1;
			}

			// TEST 2: matrix multiplication while
			System.out.println("TEST 2: matrix multiplication while");
			System.out.println(intArrayArrayToString(result));
		}

		{

			int[][] result = {{0,0,0},{0,0,0},{0,0,0}};
			
			for (int i=0; i < SIZE; i++) 
				for (int j=0; j < SIZE; j++) 
					for (int k=0; k < SIZE; k++) 
						result[i][j] = result[i][j] + x[i][k] * y[k][j];

			// TEST 3: matrix multiplication for
			System.out.println("TEST 3: matrix multiplication for");
			System.out.println(intArrayArrayToString(result));
			
		}
		
		{
			
			int[][] result = {{0,0,0},{0,0,0},{0,0,0}};
			
			int i = 0;
			do  {
				int j = 0;
				do {
					int k = 0;
					do {
						result[i][j] = result[i][j] + x[i][k] * y[k][j];
					} while (++k < SIZE);
				} while (++j < SIZE);
			} while (++i < SIZE);
			
			// TEST 4: matrix multiplication do while
			System.out.println("TEST 4: matrix multiplication do while");
			System.out.println(intArrayArrayToString(result));
		}
		
		{
			
			String[] nameList = { "Ka Boon", "Peter", "Sanjay", "Liu Xuen" };
			

			// TEST 5: for-each loop
			System.out.println("TEST 5: for-each loop");
			for ( String name : nameList) {
				System.out.println(name);
			}
			
		}

	}

}
